package hinesm.gazoushori.gazobottun;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Font;
import java.util.ArrayList;

public class MessageWindow extends GazoBottun
{
private ArrayList<String> messagecontent=new ArrayList<String>();
private ArrayList<Message> message = new ArrayList<Message>();
private int linecount;
private int viewnum;
private boolean frameflg;
private int maxpoint;
//kihon tukawanu constracta
private MessageWindow(int x,int y,Component c)
	{
super(x,y,c);
	}
private MessageWindow(int x,int y,int width,int height,Component c)
	{
super(x,y,width,height,c);
	}
private MessageWindow(int x,int y,String s,Component c)
	{
super(x,y,s,c);
	}
private MessageWindow(int x,int y,int width,int height,String s,Component c)
	{
super(x,y,width,height,s,c);
	}

//kokokara tukau method

private MessageWindow(int x,int y,int width,int height,int lc,Component c)
	{
super(x,y,width,height,c);
setLine(lc);
setTitleFont(new Font(DEFAULT_FONT_STRING,DEFAULT_FONT_STYLE,getFontPoint()));
	}

public static MessageWindow createMessageWindow(int x,int y,int width,int height,Component c,int lc,String... s)
	{
MessageWindow ms = new MessageWindow(x,y,width,height,lc,c);
int cou=0;
ms.setMessage(" ",true,-1);
while(cou<s.length)
		{
ms.setMessage(s[cou],true,-1);
cou=cou+1;
		}
return ms;

	}

private int getFontPoint()
	{
return getFontSize(difineFontDot(getTitle(),getWidth(),getHeight()));
	}

//set Information Methods

@Override
public int difineFontDot(String s,int gW,int gH)
	{
int ngH=gH;
if(getLine()>0)
		{
ngH=gH/getLine();
		}
return super.difineFontDot(s,gW,ngH);
	}

/**
表示させる文字列を追加します。
改行が入る場合行ごとに分けて追加されます。
また、表示させる行を追加する行にする場合changeの引数にtrueを代入してください
*/
public void setMessage(String s,boolean change,int setnumber)
	{
int sn=setnumber;
int ncou=0;
if(sn<0 || sn>messagecontent.size())
		{
messagecontent.add(s);
message.add(new Message());
sn=message.size()-1;
		}
else
		{
messagecontent.set(sn,s);
sn=sn-1;
message.set(sn,new Message());
		}
if(s.indexOf("\n")==-1)
		{
try
			{
message.get(sn).setMessage(s);
ncou=ncou+1;
			}
catch(Exception e)
			{
e.printStackTrace();
			}
		}
else
		{
String kaigyou="\n";
int bnum =0;
int nnum =0;
while(nnum!=s.length())
			{
nnum=s.indexOf(kaigyou,bnum);
if(nnum==-1)
				{
nnum=s.length();
				}
message.get(sn).setMessage(s.substring(bnum,nnum));
bnum=nnum+1;
ncou=ncou+1;
			}
		}
if(change)
		{
setNowMessage(sn+1);
		}
int cou=0;
while(cou<ncou)
		{
if(message.get(sn).showMessage(cou+1).length()>maxpoint)
			{
setTitleFont(new Font(getTitleFont().getFontName(),getTitleFont().getStyle(),getFontSize(difineFontDot(message.get(sn).showMessage(cou+1),getWidth(),getHeight()))));
maxpoint=message.get(sn).showMessage(cou+1).length();
			}
cou=cou+1;
		}
	}
/**
ウィンドウの最後に表示するメッセージを番号で指定して設定します。
*/
public void setNowMessage(int n)
	{
if(n<messagecontent.size())
		{
viewnum=n;
		}
else
		{
viewnum=messagecontent.size()-1;
		}
	}

public void setLine(int n)
	{
if(n>0)
		{
linecount=n;
		}
else
		{
linecount=1;
		}
	}

public void setFrameFlag(boolean b)
	{
frameflg=b;
	}

//Get Information Metheds

/**
引き数番目に格納された番号のメッセージを返します。
(0を代入した場合は半角スペース(" ")が返されます)
格納されていない番号を引数に指定された場合も同様の文字列を返します。
*/
public String getMessage(int num)
	{
if(num>0)
		{
try
			{
return messagecontent.get(num);
			}
catch(Exception e)
			{
return messagecontent.get(0);
			}
		}
else
		{
return messagecontent.get(0);
		}
	}
/**
引数となったString型の文字列を含む文字列で、最後に格納された番号を返します。
存在しなかった場合は0を返します。
*/
public int getNum(String s)
	{
int cou=1;
while(cou<=messagecontent.size())
		{
if(getMessage(cou).indexOf(s)>=0)
			{
return cou;
			}
cou=cou+1;
		}
return 0;
	}
public int getLine()
	{
return linecount;
	}
public int getNowMessage()
	{
return viewnum;
	}
public boolean getFrameFlag()
	{
return frameflg;
	}
//shori

@Override
public void put(Graphics g)
	{
if(getFrameFlag())
		{
//枠の内部を描きます
g.setColor(this.getColor());
g.fillRect(getX()+1,getY()+1,getWidth()-1,getHeight()-1);
//枠を描きます
g.setColor(this.getFrameColor());
g.drawLine(getX(),getY()+1,getX(),getY()+getHeight()-1);//左辺
g.drawLine(getX()+1,getY(),getX()+getWidth()-1,getY());//上辺
g.drawLine(getX()+getWidth(),getY()+1,getX()+getWidth(),getY()+getHeight()-1);//右辺
g.drawLine(getX()+1,getY()+getHeight(),getX()+getWidth()-1,getY()+getHeight());//底辺
		}
//文字を描きます
g.setFont(this.getTitleFont());
g.setColor(this.getTitleColor());
int cou =1;
while(cou<=getLine())
		{
g.drawString(message.get(getNowMessage()).showMessage(showNumNow(cou)),getX(),getY()+(getFontDot()*3*cou/4));
cou=cou+1;
		}
//元の色とフォントに戻します
g.setFont(gf);
g.setColor(gc);
	}

private int showNumNow(int n)
	{
int ret=n;
if(ret<=0 || ret>message.get(getNowMessage()).getMesNum())
		{
ret=0;
		}
return ret;
	}

@Override
public void perform()
	{
setNowMessage(getNowMessage()+getLine());
	}
}
