package hinesm.gazoushori.gazobottun;

import java.awt.Component;
import java.awt.event.MouseEvent;
import java.awt.Graphics;

public class ScrollBar extends GazoBottun
{

public static final boolean MODE_VERTICAL=true;//縦向き
public static final boolean MODE_HORIZONTAL=false;//横向き
private boolean DIRECTION;//向き
private int LENGTH;//表示上のバーの長さ
private int BREADTH;//表示上の幅
private int SIZE;//表示上のバーボタンの長さ
private int CLEARANCE;//LENGTH-SIZE
//バー本体の位置
private int BAR_X;
private int BAR_Y;

private boolean visableflg;
private boolean PRESSING_FLG;

private int LOCATION;//内部的な1次元的な位置
private int LOCATION_LIMIT=0;//位置の最大値

private int clickX;
private int clickY;
private int draggingX;
private int draggingY;

private final int AUTO_MOVE_SPEED=1;

public static  final int MODE_DEFAULT=0;
private static final int MODE_BOTTUN_MOVE=1;
private static final int MODE_BACK_MOVE=2;
private int mode = MODE_DEFAULT;

private ScrollBar(int x,int y,Component c)
	{
super(x,y,c);
	}
private ScrollBar(int x,int y,int width,int height,Component c)
	{
super(x,y,width,height,c);
	}
private ScrollBar(int x,int y,String s,Component c)
	{
super(x,y,s,c);
	}
private ScrollBar(int x,int y,int width,int height,String s,Component c)
	{
super(x,y,width,height,s,c);
	}

public ScrollBar(int x,int y,int breadth,int length,boolean b,int maxlocation,Component c)
	{
super(x,y,c);
setBarLocate(x,y);
DIRECTION=b;
if(length>0)
		{
LENGTH=length;
		}
else if(length!=0)
		{
LENGTH=(length*-1);
		}
else
		{
System.out.println("0 more than length");
LENGTH=c.getWidth();
		}
BREADTH=breadth;
LOCATION=0;
reset(maxlocation);
	}

public void reset(int maxlocation)
	{
visableflg=(maxlocation>=LENGTH);
if(maxlocation==0)
		{
maxlocation=1;
		}
SIZE=(int)((double)(LENGTH*LENGTH)/(double)maxlocation);
LOCATION=((LOCATION*LOCATION_LIMIT)/maxlocation);
LOCATION_LIMIT=maxlocation;
CLEARANCE=LENGTH-SIZE;
//DIRECTIONはMODE_VERTICALがtrue、MODE_HORIZONTALがfalse
if(DIRECTION)
		{
setSize(BREADTH,SIZE);
		}
else
		{
setSize(SIZE,BREADTH);
		}
	}

public int getLocate()
	{
return LOCATION;
	}
public void setBarLocate(int x,int y)
	{
BAR_X=x;
BAR_Y=y;
	}
public void moveLocate(int d,boolean throwflg)
	{
setBarBottunLocation(LOCATION+d,throwflg);
	}
public void setBarBottunLocation(int loc,boolean throwflg)
	{
LOCATION=loc;
if(throwflg)
		{
if(LOCATION<0)
			{
LOCATION=0;
			}
else if(LOCATION>LOCATION_LIMIT)
			{
LOCATION=LOCATION_LIMIT;
			}
		}
	}

@Override
public void put(Graphics g)
	{
if(visableflg)
		{
shoriGameLoop();
try
			{
getGInfo(g);
drawFrame(g);
if(DIRECTION)
				{
//縦長時
g.drawRect(BAR_X,BAR_Y,BREADTH,LENGTH);//長方形作って・・・おしまい！
setLocation(BAR_X,BAR_Y+((CLEARANCE*LOCATION)/LOCATION_LIMIT));//表示位置は向きとLENGTH*LOCATION/LOCATION_LIMITから叩き出す
				}
else
				{
//横長時
g.drawRect(BAR_X,BAR_Y,LENGTH,BREADTH);
setLocation(BAR_X+((CLEARANCE*LOCATION)/LOCATION_LIMIT),BAR_Y);
				}
//元の色に戻します
g.setColor(gc);
			}
catch(Exception e)
			{
System.out.println(e);
			}
		}
	}
private void shoriGameLoop()
	{
if(visableflg && PRESSING_FLG)
		{
switch(mode)
			{
case MODE_BOTTUN_MOVE:
moveLocateModeBottunMove();
break;
case MODE_BACK_MOVE:
moveLocateModeBackMove();
break;
default:
break;
			}
		}
	}
//
private void moveLocateModeBottunMove()
	{
if(DIRECTION)
		{
setBarBottunLocation(((draggingY-(SIZE/2)-BAR_Y)*LOCATION_LIMIT)/CLEARANCE,true);
		}
else
		{
setBarBottunLocation(((draggingX-(SIZE/2)-BAR_X)*LOCATION_LIMIT)/CLEARANCE,true);
		}
	}
private void moveLocateModeBackMove()
	{
if(DIRECTION)
		{
if(clickY>getY()+(SIZE/2))
			{
moveLocate(AUTO_MOVE_SPEED,true);
			}
else if(clickY==getY()+(SIZE/2))
			{}
else
			{
moveLocate(-1*AUTO_MOVE_SPEED,true);
			}
		}
else
		{
if(clickX>getX()+(SIZE/2))
			{
moveLocate(AUTO_MOVE_SPEED,true);
			}
else if(clickX==getX()+(SIZE/2))
			{}
else
			{
moveLocate(-1*AUTO_MOVE_SPEED,true);
			}
		}
	}

public void shoriMousePressed(MouseEvent e)
	{
if(visableflg)
		{
PRESSING_FLG=inBarCheck(e.getX(),e.getY());//バーの中をクリックされていた場合
if(PRESSING_FLG)
			{
clickX=e.getX();
clickY=e.getY();
if(containCheck(clickX,clickY))
				{
mode=MODE_BOTTUN_MOVE;
				}
else
				{
mode=MODE_BACK_MOVE;
				}
			}
		}
	}
private boolean inBarCheck(int x,int y)
	{
if(DIRECTION)
		{
return BAR_X<=x && BAR_Y<=y && x<=(BAR_X+BREADTH) && y<=(BAR_Y+LENGTH);
		}
else
		{
return BAR_X<=x && BAR_Y<=y && x<=(BAR_X+LENGTH) && y<=(BAR_Y+BREADTH);
		}
	}
public void shoriMouseDragged(MouseEvent e)
	{
if(visableflg)
		{
if(PRESSING_FLG)
			{
draggingX=e.getX();
draggingY=e.getY();
			}
		}
	}

public void shoriMouseReleased(MouseEvent e)
	{
if(PRESSING_FLG)
		{
mode=MODE_DEFAULT;
PRESSING_FLG=false;
		}
	}

@Override
public void perform()
	{
	}
}
